/*******************************************************************************
 * Licensed Materials - Property of IBM
 * Copyright IBM Corp. 2010, 2013.  All Rights Reserved.
 * 
 * US Government Users Restricted Rights - Use, duplication or disclosure
 * restricted by GSA ADP Schedule Contract with IBM Corp.
 *******************************************************************************/
(function() {
dojo.provide("rmps.importer.ImportAdminPageInitializer");

dojo.require("dojox.lang.aspect");
dojo.require("rmps.importer.ImportDefinitionEditorInput");
dojo.require("rmps.importer.ImportStatusEditorInput");
dojo.require("rmps.importer.RequestImportEditorInput");
dojo.require("rmps.importer.ProfileImportEditorInput");
dojo.require("rmps.importer.PluginProfileImportEditorInput");
dojo.require("rmps.importer.pages.ImportPageController");
dojo.require("rmps.app.ui.internal.util.DomainRegistryUtil");
dojo.require("dojo.i18n");

var IMPORT_ACTIONS_LIST= ["status","viewDefinition", "request", "importMetamodel", "importProfile", "importPluginProfile"];

rmps.ui.editor.EditorRegistry.register("rmps.importer.ImportDefinitionEditor", function(editorInput) {
	return editorInput.declaredClass === "rmps.importer.ImportDefinitionEditorInput";
});

rmps.ui.editor.EditorRegistry.register("rmps.importer.ImportStatusEditor", function(editorInput) {
	return editorInput.declaredClass === "rmps.importer.ImportStatusEditorInput";
});

rmps.ui.editor.EditorRegistry.register("rmps.importer.RequestImportEditor", function(editorInput) {
	return editorInput.declaredClass === "rmps.importer.RequestImportEditorInput";
});

rmps.ui.editor.EditorRegistry.register("rmps.app.ui.internal.pages.design.MetamodelImportEditor", function(editorInput) {
	return editorInput.declaredClass === "rmps.app.ui.internal.pages.design.MetamodelImportEditorInput";
});

rmps.ui.editor.EditorRegistry.register("rmps.importer.ProfileImportEditor", function(editorInput) {
	return editorInput.declaredClass === "rmps.importer.ProfileImportEditorInput";
});

rmps.ui.editor.EditorRegistry.register("rmps.importer.PluginProfileImportEditor", function(editorInput) {
	return editorInput.declaredClass === "rmps.importer.PluginProfileImportEditorInput";
});

dojo.extend(dm.app.admin.ui.internal.pages.AdminPage, {
	_refreshStatus: function() {
		var statusEditor = this.pageHelper.getEditor(this._importStatusEditorInput);
		if (statusEditor) {
			statusEditor.refresh();
		}
	},
	
	getDefinitionSection: function(){
		return this._definitionSection;
	},
	
	getRequestImportSection: function(){
		return this._requestImportSection;
	},
	
	getStatusSection: function(){
		return this._statusSection;
	},
	
	getImportMetamodelSection: function() {
		return this._importMetamodelSection;
	},
	
	getImportProfileSection: function() {
		return this._importProfileSection;
	}
});

/*Register the import actions to the admin page */
dojox.lang.aspect.advise(dm.app.admin.ui.internal.pages.AdminPage, "registerExtendedActions", {
	after: function() {
		 dojox.lang.aspect.getContext().instance.registerActionsList(IMPORT_ACTIONS_LIST);
	}
});

/*Use import controller to invoke the import registered actions */
dojox.lang.aspect.advise(dm.app.admin.ui.internal.pages.AdminPage, "subscribeExtendedActions", {
	after: function() {
		var self = dojox.lang.aspect.getContext().instance;
		self.importController= new rmps.importer.pages.ImportPageController(self);
		self.subscribeAllActions(self.importController);
		
	}
});
})();