/*******************************************************************************
 * Licensed Materials - Property of IBM
 * Copyright IBM Corp. 2009, 2011.  All Rights Reserved.
 * 
 * US Government Users Restricted Rights - Use, duplication or disclosure
 * restricted by GSA ADP Schedule Contract with IBM Corp.
 *******************************************************************************/
(function() {
dojo.provide("rmps.importer.ImportDefinitionEditorInput");

dojo.require("rmps.ui.editor.EditorInput");
dojo.require("dojox.encoding.digests.MD5");

dojo.require("rmps.core.process.SecurityClient");
dojo.require("rmps.core.util.IRmpsConstants");

dojo.require("rmps.importer.util");
dojo.require("dojo.i18n");

dojo.requireLocalization("rmps.importer", "ImportCommonMessages");

var messages = dojo.i18n.getLocalization("rmps.importer", "ImportCommonMessages");

var ProcessConstants = rmps.importer.util.process;
var SecurityClient = rmps.core.process.SecurityClient;

dojo.declare("rmps.importer.ImportDefinitionEditorInput", rmps.ui.editor.EditorInput, {
	
	projectId: null,
	
	operationReport: null,
	
	constructor: function(params) {
		this.projectId = params.projectId;
	},
	
	getId: function() {
		return dojox.encoding.digests.MD5(this.declaredClass + ',' + this.projectId);
	},
	
	isLoaded: function() {
		return this.operationReport != null;
	},
	
	unload: function() {
		delete this.operationReport;
	},
	
	load: function() {
		var deferred = SecurityClient.isActionAllowed(
			ProcessConstants.Operations.IMPORTER,
			dojo.getObject("jazz.app.currentApplication").context,
			[
				ProcessConstants.Actions.CREATE,
				ProcessConstants.Actions.MODIFY,
				ProcessConstants.Actions.DELETE
			]);
		deferred.addCallback(this, function(report) {
			this.operationReport = report;
			return this;
		});
		return deferred;
	},
	
	getIconUri: function() {
		return dojo.moduleUrl("rmps.importer", "graphics/icons/importDefinition.gif");
	},
	
	getName: function() {
		return messages.importDefinition;
	},
	
	getTooltip: function() {
		return null;
	},
	
	getBasePresentationUri: function(state) {
		return rmps.core.util.IRmpsConstants.ADMIN_IMPORT_VIEW_DEFINITION;
	},
	
	isRecentlyViewedSupported: function() {
		return false;
	}
});

})();
