/*******************************************************************************
 * Licensed Materials - Property of IBM
 * Copyright IBM Corp. 2011, 2012.  All Rights Reserved.
 * 
 * US Government Users Restricted Rights - Use, duplication or disclosure
 * restricted by GSA ADP Schedule Contract with IBM Corp.
 *******************************************************************************/
(function() {
dojo.provide("uml.rmps.sample.CreateRSASampleWizard");

dojo.require("dijit._Widget");
dojo.require("dijit._Templated");
dojo.require("uml.rmps.sample.SampleHelper");
dojo.require("dojo.i18n");

dojo.requireLocalization("uml.rmps.sample", "SampleMessages");

/*
 * This class provides the Create RSA Sample section for the JTS Setup Wizard.
 *
 * Author: Cherie Revells
 */
dojo.declare("uml.rmps.sample.CreateRSASampleWizard", [dijit._Widget, dijit._Templated], {

	templateString: '<div dojoAttachPoint="rsaSampleNode" </div>',

	constructor: function(args) {
		this.sampleHelper = new uml.rmps.sample.WizardSampleHelper(true, args.wizardStep);
	},
	
	postCreate: function() {
		this.inherited(arguments);
		
		this.sampleHelper.createDetailedProgress();			
		this.startup();
	},
	
	startup: function(){
		this.sampleHelper.progress.render();
		this.rsaSampleNode.appendChild(this.sampleHelper.progress.domNode);
		this.inherited(arguments);
	}
});

/*
 * This class overrides the SampleHelper so that the Next and Finish buttons
 * of the wizard step can be greyed out as the steps are being executed.
 */
dojo.declare("uml.rmps.sample.WizardSampleHelper", uml.rmps.sample.SampleHelper, {
	
	constructor: function(openLinksInNewTab, wizardStep) {
		this.wizardStep = wizardStep;
	},

	setInProgress: function(state) {
		this.inherited(arguments);
		this.wizardStep.setInProgress(state);
	}
});

})();